
App.ApplicationController = Ember.Controller.extend({
  title: function() {
    return App.get('configs.client.publicVars.appName');
  }.property('App.configs.client.publicVars.appName'),
  subTitle: function() {
    return App.get('configs.client.publicVars.appAbout');
  }.property('App.configs.client.publicVars.appAbout'),

  breadCrumb: 'Inicio',
  resetQuery: null,
  // is connected in socket.io?
  isConnected: false,

  auth: function() {
    return App.get('auth');
  }.property('App.auth'),

  configs: function() {
    return App.get('configs');
  }.property('App.configs'),

  showOauthLogin: function() {
    if(App.get('auth.isConsumer') && !App.get('auth.devLogin')) {
      return true;
    }
    return false;
  }.property('App.auth.isConsumer'),

  currentUser: function () {
    return App.get('currentUser');
  }.property('App.currentUser'),

  isAuthenticated: function(){
    if(App.get('auth.isAuthenticated') ) {
      return true;
    }else{
      return false;
    }
  }.property('App.auth.isAuthenticated'),

  init: function() {
    this._super();
    if (window.io && window.io.socket) {
      this.setConnectionStatus();
    }
  },

  setConnectionStatus: function() {
    var self = this;
    if(window.io.socket.socket && window.io.socket.socket.connected){
      self.setProperties({
        isConnected: true,
        status: Ember.I18n.t('connected')
      });
    }
    we.events.on('socketIoConnect',function(){
      self.setProperties({
        isConnected: true,
        status: Ember.I18n.t('connected')
      });
    });
    we.events.on('socketIoDisconnect',function(){
      self.setProperties({
        isConnected: false,
        status: Ember.I18n.t('disconnected')
      });
    });
    we.events.on('socketIoReconnect',function(){
      self.setProperties({
        isConnected: true,
        status: Ember.I18n.t('connected')
      });
    });
    we.events.on('socketIoReconnecting',function(){
      self.setProperties({
        isConnected: false,
        status: Ember.I18n.t('reconnecting')
      });
    });
  }

});
